const C3 = self.C3;
self.C3_GetObjectRefTable = function () {
	return [
		C3.Plugins.Sprite,
		C3.Behaviors.EightDir,
		C3.Behaviors.bound,
		C3.Plugins.Keyboard,
		C3.Plugins.Touch,
		C3.Behaviors.Pin,
		C3.Behaviors.Turret,
		C3.Behaviors.Bullet,
		C3.Behaviors.Sin,
		C3.Behaviors.destroy,
		C3.Plugins.Audio,
		C3.Plugins.Text,
		C3.Plugins.TiledBg,
		C3.Behaviors.Rotate,
		C3.Behaviors.Physics,
		C3.Behaviors.solid,
		C3.Plugins.System.Cnds.OnLayoutStart,
		C3.Plugins.Sprite.Acts.Destroy,
		C3.Plugins.Audio.Acts.StopAll,
		C3.Plugins.Sprite.Acts.SetVisible,
		C3.Plugins.Sprite.Acts.SetSolidCollisionFilter,
		C3.Plugins.Audio.Acts.Play,
		C3.Plugins.System.Acts.Wait,
		C3.Plugins.System.Acts.CreateObject,
		C3.Plugins.System.Exps.random,
		C3.Behaviors.Bullet.Acts.SetEnabled,
		C3.Plugins.Sprite.Acts.SetCollisions,
		C3.Behaviors.Sin.Acts.SetEnabled,
		C3.Plugins.Keyboard.Cnds.IsKeyDown,
		C3.Plugins.Touch.Cnds.IsTouchingObject,
		C3.Behaviors.EightDir.Acts.SimulateControl,
		C3.Plugins.Keyboard.Cnds.OnKey,
		C3.Plugins.Touch.Cnds.OnTapGestureObject,
		C3.Plugins.Sprite.Acts.Spawn,
		C3.Plugins.Sprite.Cnds.CompareInstanceVar,
		C3.Plugins.Sprite.Acts.SetAngle,
		C3.Plugins.System.Cnds.EveryTick,
		C3.Plugins.Sprite.Acts.SetHeight,
		C3.Plugins.Text.Acts.SetText,
		C3.Plugins.System.Cnds.CompareVar,
		C3.Plugins.System.Acts.SetVar,
		C3.Plugins.System.Acts.RestartLayout,
		C3.Plugins.Sprite.Cnds.OnDestroyed,
		C3.Plugins.System.Acts.SubVar,
		C3.Plugins.Sprite.Acts.SetOpacity,
		C3.Behaviors.Pin.Acts.PinByDistance,
		C3.Behaviors.Pin.Acts.SetPinDistance,
		C3.Behaviors.Turret.Acts.AcquireTarget,
		C3.Behaviors.Turret.Acts.SetRotate,
		C3.Plugins.Sprite.Cnds.OnCreated,
		C3.Behaviors.Bullet.Acts.SetSpeed,
		C3.Plugins.Sprite.Cnds.OnCollision,
		C3.Plugins.Sprite.Acts.SetInstanceVar,
		C3.Plugins.System.Acts.AddVar,
		C3.Plugins.Sprite.Acts.AddInstanceVar,
		C3.Plugins.System.Cnds.Every,
		C3.Plugins.Sprite.Cnds.CompareFrame,
		C3.Plugins.Sprite.Acts.SetAnim,
		C3.Plugins.Sprite.Acts.MoveToTop,
		C3.Plugins.Sprite.Cnds.CompareX,
		C3.Plugins.Sprite.Cnds.IsOnScreen,
		C3.Behaviors.Bullet.Acts.SetAngleOfMotion,
		C3.Plugins.Sprite.Acts.MoveToBottom,
		C3.Plugins.Sprite.Acts.SetAnimFrame,
		C3.Behaviors.Rotate.Acts.SetSpeed,
		C3.Behaviors.Bullet.Exps.Speed,
		C3.Plugins.Sprite.Acts.SetScale,
		C3.Behaviors.solid.Acts.SetTags,
		C3.Behaviors.Physics.Acts.SetDensity,
		C3.Plugins.Sprite.Exps.Width,
		C3.Plugins.Sprite.Exps.Height,
		C3.Plugins.Sprite.Acts.SubInstanceVar,
		C3.Plugins.Sprite.Cnds.IsCollisionEnabled
	];
};
self.C3_JsPropNameTable = [
	{PlayerHP: 0},
	{Lasers: 0},
	{Drones: 0},
	{EnemiesDefeated: 0},
	{"8Direction": 0},
	{BoundToLayout: 0},
	{Player: 0},
	{Keyboard: 0},
	{Touch: 0},
	{Pin: 0},
	{Turret: 0},
	{Drone: 0},
	{Drone2: 0},
	{Drone3: 0},
	{Drone4: 0},
	{UpgradeRandomizer: 0},
	{Bullet: 0},
	{Sine: 0},
	{EnemyFighter: 0},
	{DestroyOutsideLayout: 0},
	{Vulcan: 0},
	{Audio: 0},
	{Laser: 0},
	{Star: 0},
	{Star2: 0},
	{Planet: 0},
	{EnemyLaser: 0},
	{LifeBar: 0},
	{LaserUpgrade: 0},
	{DroneUpgrade: 0},
	{LivesText: 0},
	{ScoreText: 0},
	{Background: 0},
	{TouchUp: 0},
	{TouchRight: 0},
	{TouchDown: 0},
	{TouchLeft: 0},
	{TouchFire: 0},
	{EnemyHP: 0},
	{SentinelStarBlade: 0},
	{StationZetaBackground: 0},
	{SentinelBullet: 0},
	{Rotate: 0},
	{Physics: 0},
	{Solid: 0},
	{Asteroid: 0},
	{Chameleon: 0},
	{ChameleonBullet: 0},
	{TotalDefeatedText: 0},
	{Sprite: 0},
	{Lives: 0},
	{Score: 0}
];

self.InstanceType = {
	Player: class extends self.ISpriteInstance {},
	Keyboard: class extends self.IInstance {},
	Touch: class extends self.IInstance {},
	Drone: class extends self.ISpriteInstance {},
	Drone2: class extends self.ISpriteInstance {},
	Drone3: class extends self.ISpriteInstance {},
	Drone4: class extends self.ISpriteInstance {},
	EnemyFighter: class extends self.ISpriteInstance {},
	Vulcan: class extends self.ISpriteInstance {},
	Audio: class extends self.IInstance {},
	Laser: class extends self.ISpriteInstance {},
	Star: class extends self.ISpriteInstance {},
	Star2: class extends self.ISpriteInstance {},
	Planet: class extends self.ISpriteInstance {},
	EnemyLaser: class extends self.ISpriteInstance {},
	LifeBar: class extends self.ISpriteInstance {},
	LaserUpgrade: class extends self.ISpriteInstance {},
	DroneUpgrade: class extends self.ISpriteInstance {},
	LivesText: class extends self.ITextInstance {},
	ScoreText: class extends self.ITextInstance {},
	Background: class extends self.ITiledBackgroundInstance {},
	TouchUp: class extends self.ISpriteInstance {},
	TouchRight: class extends self.ISpriteInstance {},
	TouchDown: class extends self.ISpriteInstance {},
	TouchLeft: class extends self.ISpriteInstance {},
	TouchFire: class extends self.ISpriteInstance {},
	SentinelStarBlade: class extends self.ISpriteInstance {},
	StationZetaBackground: class extends self.ITiledBackgroundInstance {},
	SentinelBullet: class extends self.ISpriteInstance {},
	Asteroid: class extends self.ISpriteInstance {},
	Chameleon: class extends self.ISpriteInstance {},
	ChameleonBullet: class extends self.ISpriteInstance {},
	TotalDefeatedText: class extends self.ITextInstance {},
	Sprite: class extends self.ISpriteInstance {}
}